'---------------------------------------------------
'------------DateTicker v0.1------------------------
'---------------------------------------------------
' This was a quickie I threw together as a countdown 
' to my wedding. :)...just thought I'd share it.
' Essentially, it's a countdown timer to a date that you
' specify.
' I got the best results by hybridizing the methods 
' by which the data was called.
'
' It's not perfect, but it seems to work well so far.
' Any problems, let me know.
'
' fritistat1@aol.com 
'
' ----------------------------------------------------
' History:
'
' v0.1 - Initial release
'-----------------------------------------------------
' The following values may be adjusted to your liking:
'-----------------------------------------------------

Const TargetDate = "06/05/04"   '<----- Change the date between the quotes to your target date
				'	(In MM/DD/YY format)
Const CompactDisplay = 0        '<----- Choose one of two values:
                                '        0 = Display the countdown on a single line
                                '        1 = Display each unit of time on its own line

Const UseCommas = 1             '<----- Choose one of two values:
                                '        0 = Do not display commas between values
                                '        1 = Display commas between values



'CODE BELOW ---DO NOT ALTER--------------------------------------------------------------------
'//////////////////////////////////////////////////////////////////////////////////////////////

Public Function DateTicker()

Dim D, DNew, Hr, Min, Sec, TimeToTarget, MaybeComma

TimeToTarget = DateDiff("s", Now, targetdate) 

d2 = Day(TargetDate)
m2 = Month(TargetDate)
Y2 = Year(TargetDate)
d1 = Day(Now)
m1 = Month(Now)
Y1 = Year(Now)

If d2 < d1 Then m2 = m2 - 1: d2 = d2 + 30
If m2 < m1 Then Y2 = Y2 - 1: m2 = 12 + m2

If UseCommas = 1 Then
MaybeComma = ", "
Else
MaybeComma = " "
End If

y = Abs(Y2 - Y1)

    If y = 0 Then
    y = ""
    ElseIf y = 1 Then
    y = y & " year" & MaybeComma
    Else
    y = y & " years" & MaybeComma
    End If

m = Abs(m2 - m1)

    If m = 0 Then
    m = ""
    ElseIf m = 1 Then
    m = m & " month" & MaybeComma
    Else
    m = m & " months" & MaybeComma
    End If

D = Abs(d2 - d1)  
     
    If d = 0 or TimeToTarget < 86400 Then
    d = ""
    ElseIf d = 1 Then
    d = d & " day" & MaybeComma
    else
    d = d & " days" & MaybeComma
    End If

'DNew = TimeToTarget \ 86400
    TimeToTarget = TimeToTarget Mod 86400   
 
Hr = TimeToTarget \ 3600
    TimeToTarget = TimeToTarget Mod 3600
    
    If Hr = 0 Then
    Hr = ""
    ElseIf Hr = 1 Then
    Hr = Hr & " hour" & MaybeComma
    Else
    Hr = Hr & " hours" & MaybeComma
    End If
        
    
Min = TimeToTarget \ 60
    TimeToTarget = TimeToTarget Mod 60
    
    If Min = 0 Then
    Min = ""
    ElseIf Min = 1 Then
    Min = Min & " minute" & MaybeComma
    Else
    Min = Min & " minutes" & MaybeComma
    End If
    
Sec = TimeToTarget

    If Sec = 0 Then
    Sec = ""
    ElseIf Sec = 1 Then
    Sec = Sec & " second"
    Else
    Sec = Sec & " seconds"
    End If

If CompactDisplay = 0 Then
DateTicker = y & m & D & Hr & Min & Sec
Else
DateTicker = y & vbCrLf & m & vbCrLf & D & vbCrLf & Hr & vbCrLf & Min & vbCrLf & Sec
End If

End Function
